<?php

class Andy_FirstPostEmail_DataWriter extends XFCP_Andy_FirstPostEmail_DataWriter
{
	public function save()
	{		
		// call parent
		parent::save();
		
		// get user information
		$visitor = XenForo_Visitor::getInstance();
		$messageCount = $visitor['message_count'];
		
		if ($messageCount == 0 AND $visitor['username'] != '')
		{
			//########################################
			// prepare mail variables
			//########################################
				
			// get options from Admin CP -> Options -> First Post Email -> Name     
			$username = XenForo_Application::get('options')->firstPostEmailName;		
			
			// remove trailing comma if there is one
			$username = rtrim($username, ',');			
			
			// put into array
			$username = explode(',', $username);					
			
			// get options from Admin CP -> Options -> First Post Email -> Email To    
			$emailTo = XenForo_Application::get('options')->firstPostEmailEmailTo;
			
			// remove trailing comma if there is one
			$emailTo = rtrim($emailTo, ',');			
			
			// put into array
			$email = explode(',', $emailTo);					
			
			// subject					
			$subject = new XenForo_Phrase('firstpostemail_first_post_for') . ' ' . $visitor['username'];	
			
			// get database
			$db = XenForo_Application::get('db');
			
			// run query
			$postId = $db->fetchOne("
				SELECT post_id
				FROM xf_post
				WHERE user_id = ?
				ORDER BY post_id ASC
			", $visitor['user_id']);
			
			// continue only if we have a postId
			if ($postId != '')
			{
				// get webRoot
				$webRoot =  XenForo_Link::buildPublicLink('full:index');				
				
				$message = '<a href="' . $webRoot . 'posts/' . $postId . '/">' . new XenForo_Phrase('firstpostemail_click_here_to_view_post') . '</a>';			
				
				//########################################
				// send mail
				//########################################
				
				$count = count($email);

				for ($i=0; $i<$count; $i++)
				{
					// define user variable
					$user = array(
						'username' => $username[$i],
						'email' => $email[$i]
					);
					
					// prepare mailParams                    
					$mailParams = array(
						'user' => $user,
						'subject' => $subject,
						'message' => $message
					);
						
					// prepare mail variable
					$mail = XenForo_Mail::create('firstpostemail_contact', $mailParams);
					
					// send mail
					$mail->queue($user['email'], $user['username']);
				}
			}
		}
	}
}